// Illustration of the "call by value" semantics of java method calls.
// Copies of primites are passed into functions such as in doubler1().
// This means the original value passed in is unmodified outside the
// function.  All types aside from primitives are passed by reference.
// Since arrays are an array type, calling functions will see the
// change that doubler2() makes to the 0th element of the parameter
// array.  It is important that you be able to construct a memory
// diagram of the stack and heap that illustrates this situation.
public class Doubler{
  public static void doubler1(int x){
    x = 2*x;
  }
  public static void doubler2(int x[]){
    x[0] = 2*x[0];
  }
  public static void main(String args[]){
    int r = 10;
    int s[] = {20};

    doubler1(r);
    doubler2(s);

    System.out.printf("r: %d  s[0]: %d\n",r,s[0]);
  }
}
