// Demonstrate basic function syntax
public class MethodDemo{
  // Returns an int, takes no arguments
  public static int one(){	
    return 1;
  }

  // Returns a double,  takes one double
  public static double timesTwo(double d){ // Only one of these
    return d*2;
  }

  // Return +1.0 if x is positive, -1.0 if x is negative, and 0.0 if x
  // is exactly 0
  public static double sign(double x){
    if(x > 0.0){
      return 1.0;
    }
    else if(x < 0.0) {
      return -1.0;
    } else{
      return 0.0;
    }
  }

  // Return true if x is positive and false otherwise
  public boolean isPositive(double x){
    if(x > 0.0){
      return true;
    }
    else{
      return false;
    }
  }

  // Exercise: Write a function allPositive(a) which mimics is
  // isPositive(x) on an array argument

  // Sum up an array, returns an int, takes an int array
  public static int sumIntArray(int a[]){
    int sum = 0;
    for(int i=0; i<a.length; i++){
      sum += a[i];
    }
    return sum;
  }

  // Takes 3 doubles, returns a double
  // An awful, awful way to code this
  public static double max3(double x, double y, double z){
    if(x < y){
      if(y < z){
	return z;
      }
      else{
	return y;
      }
    }
    else {
      if(x < z){
	return z;
      }
      else{
	return x;
      }
    }
  }

  // A void fuction : does stuff for side effects and doesn't produce
  // a return value
  public static void downHere(){ 
    System.out.println("Calling down here");
  }

  // More readableway of coding max
  public static double max3Readable(double x, double y, double z){
    double max = x;
    if(y > max){
      max = y;
    }
    if(z > max){
      max = z;
    }
    return max;
  }

    
  public static void main(String[] args){
    System.out.println("Add some function calls in main or ");
    System.out.println("use DrJava to play with the functions");
  }

}
